szaml   equ     posi             ; szaml igny kielgtve
buf	equ	chars

bibcd16
  movlw  16
  movwf  szaml
  clc
  clrf	bl
  clrf  ch
  clrf  cl
bibnul
  rlf  al,f
  rlf  ah,f
  decf  szaml,f
  sz
  goto	bibcont
  snc
  incf	cl,f
  return
bibcont
  sc
  goto  bibnul
  rlf  cl,f
  rlf  ch,f
  rlf  bl,f
  rlf  al,f
  rlf  ah,f
  rlf  cl,f
  rlf  ch,f
  rlf  bl,f
  decf  szaml,f
  snz
  return
dhurok
  rlf  al,f
  rlf  ah,f
  rlf  cl,f
  rlf  ch,f
  rlf	bl,f
  decfsz szaml,f
  goto  dadj
  return
dadj
  movlw cl
  movwf fsr0l
  call  bcadj
  movlw  ch
  movwf  fsr0l
  call  bcadj
  movlw  bl
  movwf	fsr0l
  call  bcadj
  goto  dhurok
; bcd korrekci
bcadj
  movlw  3
  addwf  indf0,w
  movwf  buf
  snb  buf,3
  movwf  indf0
  movlw  30h
  addwf  indf0,w
  movwf buf
  snb  buf,7
  movwf  indf0
  return

; bibc24: 24 bit binrisrl 8 digit csomagolt bcd-re
; A binris Au, Ah, Al-ben, a BCD eredmny Bh, Bl,Ch,Cl-ben.
; Van neki 2 db munkaragiszter (szaml s buf) ignye.
; FSR-t is hasznlja. Bels szubrutinos vltozat. bibcw belpsi ponttal
; w-ben tadott szm bitet konvertl Ahh MSB-jtl kezdve.
; posi s chars tlterhelve, de a kijelzsig felszabadul s viszont


bibc24
	movlw	24           ; ettl 24 bites
bibcw				; itt belpve w bites (max. 26)
	movwf   szaml
	clc
	clrf    bl              
	clrf    ch
	clrf    bh
	clrf    cl              ; eredmny trlse              
bibnul24
	rlf     al,f               
	rlf     ah,f              
	rlf     au,f             ; 
	decf    szaml,f
	sz
	goto bcont24
	snc
	incf	cl,f
	return
bcont24
	sc                      ; addig lpteti balra az osztandt, amg
	goto    bibnul24	; egy '1' rtk bitet nem fog.
	rlf     cl,f              ; ez itt az eredmny legkisebb bjtja,
	rlf     ch,f              ; innen kezdve lpnek majd be a jegyek.
	rlf     bl,f             ; felvesz 2 digitet
	rlf     bh,f              ; ez tlterhelhet 1-gyel, megvan a 8

	rlf     al,f              ; osztand volt
	rlf     ah,f
	rlf     au,f

	rlf     cl,f              ; eredmny lesz
	rlf     ch,f
	rlf     bl,f
	rlf     bh,f              ; bevett 2 bitet, itt mg nincs korrekci.

	decf    szaml,f
	snz
        return                     ; kilp, ha ennyi volt
dhurok24
	rlf     al,f              ; ha maradtak mg bitek:
	rlf     ah,f
	rlf     au,f

	rlf     cl,f
	rlf     ch,f
	rlf     bl,f
	rlf     bh,f              ; tveszi, s korrigl, mg el nem fogy
	djnz    szaml,dadj24      ; utols lptets utn nem korrigl ?!
	return
dadj24
	movl    fsr0l,cl         ; minden eredmnybjtra bcadj
	call    bcadj
	movl    fsr0l,ch
	call    bcadj
	movl    fsr0l,bl
	call    bcadj
	movl    fsr0l,bh
	call    bcadj
	goto    dhurok24

; bin to packed dec, 1 bjtos eljel nlkli egsz aux-bl.
; dec2 dec1 dec0 a tnyleges memriasorrend,de sszepakolja
; dec1 dec0-ra. 
BDAUX		; kzs, aux-bl
	banksel	0
	MOVL	DEC2,-1
	MOVLW	100
BDL
	INCF	DEC2,F
	SUBWF	AUX,F
	SNC
	GOTO	BDL
	ADDWF	AUX,F
	MOVL	DEC1,-1
	MOVLW	10
BDL1
	INCF	DEC1,F
	SUBWF	AUX,F
	SNC
	GOTO	BDL1
	ADDWF	AUX,W
	MOVWF	DEC0
	swapf	dec1,w
	addwf	dec0,f
	movf	dec2,f
	movwf	dec1
	RETURN
	
expandbcd
	swapf	indf0,w
	andlw	0fh
	iorlw	30h
	movwi	fsr1++
	moviw	fsr0++
	andlw	0fh
	iorlw	30h
	movwi	fsr1++
	decfsz	count,f
	goto	expandbcd
	return
lzs
	bcf     nlead		; leading zero supression (indirekt mezre)
lzslp
	decf	count,w 	; ha utols, a nullt is ki kell rni
        snz
        bsf     nlead
        andl    indf0,3fh
        movf    indf0,w
        iorlw   30h
        xorlw	30h
        sz
        bsf     nlead           ; az els nem nulltl kezdve mindent kir
        movf    indf0,w
        sb      nlead
        andlw	2fh
        movwi	fsr0++
        djnz    count,lzslp
        return

; A prep-ek mindenkpp telerjk nullval a mezket, nincs rjuk lzs
prep1
	movl	fsr0l,low lcb1
	movlw	20h
	movwi	fsr0++
	movwi	fsr0++
	movlw	30h
	movwi	fsr0++
	movwi	fsr0++
	movwi	fsr0++
	movwi	fsr0++
	movwi	fsr0++
	movlw	20h
	movwi	fsr0++
	movlw	30h
	movwi	fsr0++
	movwi	fsr0++
	movlw	"/"
	movwi	fsr0++
	movlw	"3"
	movwi	fsr0++
	movlw	"2"
	movwi	fsr0++
	movlw	20h
	movwi	fsr0++
	movlw	"u"
	movwi	fsr0++
	movlw	"s"
	movwi	fsr0++
	goto	out1
prep2
	movl	fsr0l,low lcb2
	movlw	20h
	movwi	fsr0++
	movwi	fsr0++
	movwi	fsr0++
	movwi	fsr0++
	movwi	fsr0++
	movlw	30h
	movwi	fsr0++
	movwi	fsr0++
	movwi	fsr0++
	movwi	fsr0++
	movwi	fsr0++
	movwi	fsr0++
	movwi	fsr0++
	movwi	fsr0++
	movlw	20h
	movwi	fsr0++
	movlw	"u"
	movwi	fsr0++
	movlw	"s"
	movwi	fsr0++
	goto	out2

out1
	movl	fsr0l,lcb1+1
	movl	count,6
	call	lzs
	movl	fsr0l,lcb1+8
	movl	count,2
	call	lzs
	goto	dv1611
	
out2
	movl	fsr0l, lcb2+5
	movl	count,8
	call	lzs
	goto	dv1612